/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.AlamatDto;
import com.portofolio.service.AlamatService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/alamat")
public class AlamatController extends LocaleController {
	@Lazy
	@Autowired
	private AlamatService alamatService;

	
	@ApiOperation("Api Untuk Menyimpan Alamat")
	@PostMapping("/save")
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody AlamatDto entity, HttpServletRequest request) {
		Map<String, Object> result = alamatService.save(entity);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Update Alamat")
	@PutMapping("/update")
	public ResponseEntity<Map<String, Object>> update(
			@RequestParam(value = "kdAlamat", required = true) Integer kdAlamat,
			@RequestParam(value = "version", required = true) Integer version,
			@Valid @RequestBody AlamatDto alamatDto,
			HttpServletRequest request) {
		Map<String, Object> result = alamatService.update(alamatDto, kdAlamat, version);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Menghapus Alamat BerdasarkanKdAlamat")
	@DeleteMapping("/delete")
	public ResponseEntity<Map<String, Object>> deleteById(
			@RequestParam(value = "kdAlamat", required = true) Integer kdAlamat,
			@RequestParam(value = "version", required = true) Integer version
			) {
		Map<String, Object> result = alamatService.deleteByKdAlamat(kdAlamat, version);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Menampilkan Semua Alamat")
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> grid(@RequestParam(value = "page", defaultValue = "1") Integer page,
			@RequestParam(value = "rows", defaultValue = "10") Integer rows,
			@RequestParam(value = "dir", defaultValue = "alamatLengkap") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "alamatLengkap", required = false) String alamatLengkap,
			@RequestParam(value = "enumAlamat", required = true,defaultValue = "Profile") String enumAlamat) {
		Map<String, Object> result = alamatService.grid(page, rows, sort, dir, alamatLengkap,enumAlamat);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menampilkan Enum Alamat")
	@GetMapping("/getEnumAlamat")
	public ResponseEntity<Map<String, Object>> gridAlamatProfile() {
		Map<String, Object> result = alamatService.getEnumAlamat();
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Untuk Menampilkan Alamat Berdasarkan kode")
	@GetMapping("/findByKdAlamat")
	public ResponseEntity<Map<String, Object>> findByKdAlamat(
			@RequestParam(value = "kdAlamat", required = true) Integer kdAlamat, 
			HttpServletRequest request) {
		Map<String, Object> result = alamatService.findByKdAlamat(kdAlamat);
		return RestUtil.getJsonResponse(result);
	}
	

}
